<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.5"/>
<title>fwInstallation: fwInstallationDBCache.ctl File Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td style="padding-left: 0.5em;">
   <div id="projectname">fwInstallation
   &#160;<span id="projectnumber">8.4.2</span>
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.5 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li><a href="examples.html"><span>Examples</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
      <li><a href="globals.html"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
</div><!-- top -->
<div class="header">
  <div class="summary">
<a href="#func-members">Functions</a> &#124;
<a href="#var-members">Variables</a>  </div>
  <div class="headertitle">
<div class="title">fwInstallationDBCache.ctl File Reference</div>  </div>
</div><!--header-->
<div class="contents">
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="func-members"></a>
Functions</h2></td></tr>
<tr class="memitem:a1ff2414838beeed73295d4b5e7dab465"><td class="memItemLeft" align="right" valign="top">string&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="fwInstallationDBCache_8ctl.html#a1ff2414838beeed73295d4b5e7dab465">_fwInstallationDbCache_getCacheKey</a> (string functionKey, dyn_mixed parameters, string index=&quot;&quot;)</td></tr>
<tr class="separator:a1ff2414838beeed73295d4b5e7dab465"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a25615ed7c123652bc2069fe3396b8319"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="fwInstallationDBCache_8ctl.html#a25615ed7c123652bc2069fe3396b8319">fwInstallationDBCache_setCaches</a> (string functionKey, dyn_mixed parameters, dyn_anytype values, dyn_string valuesIndexes)</td></tr>
<tr class="separator:a25615ed7c123652bc2069fe3396b8319"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:adfb4171c4e93579cf258e15c2ff57669"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="fwInstallationDBCache_8ctl.html#adfb4171c4e93579cf258e15c2ff57669">fwInstallationDBCache_setCache</a> (string functionKey, dyn_mixed parameters, anytype value, string index=&quot;&quot;)</td></tr>
<tr class="separator:adfb4171c4e93579cf258e15c2ff57669"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a27b3fec03e1a0061dc5af488fbdfd0e1"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="fwInstallationDBCache_8ctl.html#a27b3fec03e1a0061dc5af488fbdfd0e1">fwInstallationDBCache_getCache</a> (string functionKey, dyn_mixed parameters, anytype &amp;returnValue, string index=&quot;&quot;)</td></tr>
<tr class="separator:a27b3fec03e1a0061dc5af488fbdfd0e1"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="var-members"></a>
Variables</h2></td></tr>
<tr class="memitem:a098f38dba91e7c0156e93770f876193a"><td class="memItemLeft" align="right" valign="top">const string&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="fwInstallationDBCache_8ctl.html#a098f38dba91e7c0156e93770f876193a">csFwInstallationDBCacheLibVersion</a> = &quot;8.4.2&quot;</td></tr>
<tr class="separator:a098f38dba91e7c0156e93770f876193a"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
<div class="textblock"><p>This library contains the implementation of cache functions to the fwInstallationDB interface.</p>
<dl class="section author"><dt>Author</dt><dd>Daniel Rodrigues (EN-ICE/SIC) </dd></dl>
<dl class="section version"><dt>Version</dt><dd>0.6 corrected error on _fwInstallationDbCache_getCacheKey </dd></dl>
<dl class="section date"><dt>Date</dt><dd>August 2011</dd></dl>
<p>version 0.6 adding an useCache flag, normally set to false, only true if initialized. eliminating the uptodate mechanism (clearing the db not so elegant but working) version 0.5 changing a mapping based cache, depending on function names and parameters version 0.3 Testing version version 0.2 modifying architecture: new "setCache" parameter, cache controlled from fwInstallationDB to avoid infinite loop cache set from outside. version 0.1 Initial porting of all functions with SELECT import </p>
<pre class="fragment">TODO: think about having a get/set tuple for each function instead of "loadCache"</pre></div><h2 class="groupheader">Function Documentation</h2>
<a class="anchor" id="a1ff2414838beeed73295d4b5e7dab465"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">string _fwInstallationDbCache_getCacheKey </td>
          <td>(</td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>functionKey</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">dyn_mixed&#160;</td>
          <td class="paramname"><em>parameters</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>index</em> = <code>&quot;&quot;</code>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>gets cache key based on function name, parameterValues, value, etc. </p>

</div>
</div>
<a class="anchor" id="a25615ed7c123652bc2069fe3396b8319"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int fwInstallationDBCache_setCaches </td>
          <td>(</td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>functionKey</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">dyn_mixed&#160;</td>
          <td class="paramname"><em>parameters</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">dyn_anytype&#160;</td>
          <td class="paramname"><em>values</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">dyn_string&#160;</td>
          <td class="paramname"><em>valuesIndexes</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Set a number of cache values.</p>
<p>alternative </p>

</div>
</div>
<a class="anchor" id="adfb4171c4e93579cf258e15c2ff57669"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int fwInstallationDBCache_setCache </td>
          <td>(</td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>functionKey</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">dyn_mixed&#160;</td>
          <td class="paramname"><em>parameters</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">anytype&#160;</td>
          <td class="paramname"><em>value</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>index</em> = <code>&quot;&quot;</code>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Set value in Cache for a given function, parameters, and index </p>
<dl class="section return"><dt>Returns</dt><dd>0 of successful TODO : evaluate possibility of non forcable flag (return -1 if value already in cache) </dd></dl>

</div>
</div>
<a class="anchor" id="a27b3fec03e1a0061dc5af488fbdfd0e1"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int fwInstallationDBCache_getCache </td>
          <td>(</td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>functionKey</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">dyn_mixed&#160;</td>
          <td class="paramname"><em>parameters</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">anytype &amp;&#160;</td>
          <td class="paramname"><em>returnValue</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>index</em> = <code>&quot;&quot;</code>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Get cached value for function, parameters, index to &amp;value </p>
<dl class="section return"><dt>Returns</dt><dd>0 if successful </dd>
<dd>
-1 if value is not cached. </dd>
<dd>
-2 if cache is not to be used. </dd></dl>

</div>
</div>
<h2 class="groupheader">Variable Documentation</h2>
<a class="anchor" id="a098f38dba91e7c0156e93770f876193a"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">const string csFwInstallationDBCacheLibVersion = &quot;8.4.2&quot;</td>
        </tr>
      </table>
</div><div class="memdoc">
<p>This script implements an interface to the gDbCache object for the installation tool</p>
<ol type="1">
<li>All functions that select information from the database in fwInstallationDB are replicated in gDbCache a. Stored as a compound string of functionname::(parameters:);</li>
<li>Returns the necessary variable if: a. gDbCache is uptodate (gDbCache["isUptodate"] == true ) and b. mapping exists for the compound string exists and c. loadCache = false.</li>
<li>if loadCache is true, a. Sets the mapping compoundstring, value(s) Version of this library. Used to determine the coherency of all libraries of the installation tool Please do not edit it manually </li>
</ol>

</div>
</div>
</div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.5
</small></address>
</body>
</html>
